unit untMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ToolWin, ExtCtrls, ImgList,
  Menus, Contnrs, untTool, untBBSCore,
  untGlobal, untBoard, untTopicBrowser,
  untSearchForm, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  unt2chUrlParser, untTopicBrowserIE, untTopicBrowserDoe,
  untUpdateBoardForm,
  ShellAPI, Clipbrd, untBoardList, IdAntiFreezeBase, IdAntiFreeze,
  IdCookieManager, Math, ActnList, untLoginForm, StrUtils,
  untCreateOfflineFolder, Commctrl, untHintWindow,
  untEditBoardButttonForm, untLogSweeperForm, ShDocVw_TLB,
  untImageListTool, Taskbar, mmsystem, untOptionForm, untTopic, untWriteForm;

type
  TBoardListBoxItem = class
  public
    Category      : TBoardCategory;
    Board         : TBoard;
    ViewString    : string;
  end;

  TMainForm = class(TForm)
    AddressToolBar : TToolBar;
    GoToToolButton : TToolButton;
    ToolBarImageList: TImageList;
    TopicListViewImageList: TImageList;
    Splitter1: TSplitter;
    RightPanel: TPanel;
    Splitter2: TSplitter;
    BrowserPanel: TPanel;
    TopicToolBar: TToolBar;
    ViewLimitToolButton: TToolButton;
    DownloadTopicToolButton: TToolButton;
    StopToolButton: TToolButton;
    ToolButton8: TToolButton;
    ToolButton12: TToolButton;
    TopicWriteToolButton: TToolButton;
    FavoriteToolButton: TToolButton;
    ToolButton15: TToolButton;
    TrashToolButton: TToolButton;
    CloseTabToolButton: TToolButton;
    TopicListViewPopupMenu: TPopupMenu;
    OpenNewTabMenuItem: TMenuItem;
    BoardNameLabel: TLabel;
    TopicNameLabel: TLabel;
    TopicPagePopupMenu: TPopupMenu;
    CloseMenuItem: TMenuItem;
    CloseAllMenuItem: TMenuItem;
    CloseWithoutMenuItem: TMenuItem;
    CopyUrlMenuItem: TMenuItem;
    CopyTitleUrlMenuItem: TMenuItem;
    OpenByBrowserMenuItem: TMenuItem;
    N01: TMenuItem;
    N7: TMenuItem;
    AutoReloadMenuItem: TMenuItem;
    TopicTabControl: TTabControl;
    ToolPopupMenu: TPopupMenu;
    OptionMenuItem: TMenuItem;
    N5: TMenuItem;
    UpdateBoardListMenuItem: TMenuItem;
    N9: TMenuItem;
    ViewLimitPopupMenu: TPopupMenu;
    ViewLimit50MenuItem: TMenuItem;
    ViewLimit100MenuItem: TMenuItem;
    ViewLimit250MenuItem: TMenuItem;
    ViewLimit500MenuItem: TMenuItem;
    ViewLimit1000MenuItem: TMenuItem;
    ViewLimitNothingMenuItem: TMenuItem;
    TopicListView: TListView;
    CoolBar: TCoolBar;
    MainToolBar: TToolBar;
    SearchToolButton: TToolButton;
    PatrolToolButton: TToolButton;
    MakeTopicToolButton: TToolButton;
    StyleToolButton: TToolButton;
    StyleSub1ToolButton: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    UrlEdit: TEdit;
    BoardButtonToolBar: TToolBar;
    BoardButton: TToolButton;
    AddressBarPopupMenu: TPopupMenu;
    N1: TMenuItem;
    URL3: TMenuItem;
    ToolButton4: TToolButton;
    ToolButton3: TToolButton;
    StyleSub2ToolButton: TToolButton;
    StyleSub3ToolButton: TToolButton;
    MainStatusBar: TStatusBar;
    RepaintTabTimer: TTimer;
    RepaintListViewTimer: TTimer;
    DownloadAllTopicToolButton: TToolButton;
    BoardListBoxPopupMenu: TPopupMenu;
    RegisterBoardButtonMenuItem: TMenuItem;
    N3: TMenuItem;
    CopyBoardUrlMenuButton: TMenuItem;
    OpenBoardByBrowserMenuItem: TMenuItem;
    IdAntiFreeze1: TIdAntiFreeze;
    LeftPanel: TPanel;
    BoardListBox: TListBox;
    ComboBox1: TComboBox;
    ArticlePopupMenu: TPopupMenu;
    N2: TMenuItem;
    LoginMenuItem: TMenuItem;
    N4: TMenuItem;
    SetPriorityMenuItem: TMenuItem;
    InputMemoMenuItem: TMenuItem;
    CopyUrlTopicList: TMenuItem;
    CopyTitleUrlTopicList: TMenuItem;
    OpenByBrowserTopicList: TMenuItem;
    N11: TMenuItem;
    TrashMenuItem: TMenuItem;
    ResAtMenuItem: TMenuItem;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    BoardButtonPopupMenu: TPopupMenu;
    BoardDeleteMenuItem: TMenuItem;
    ActionList1: TActionList;
    ReceiveActiveTabAction: TAction;
    CloseActiveTabAction: TAction;
    TabForwardAction: TAction;
    TabBeforeAction: TAction;
    ChangeLimitAllActiveTab: TAction;
    ChangeStyle1Action: TAction;
    ChangeStyle2Action: TAction;
    ChangeStyle3Action: TAction;
    CreateOfflineFolder: TMenuItem;
    FavoritePopupMenu: TPopupMenu;
    RemoveOfflineFolder: TMenuItem;
    SetPriorityPlus3ItemMenu: TMenuItem;
    SetPriorityPlus2ItemMenu: TMenuItem;
    SetPriorityPlus1ItemMenu: TMenuItem;
    SetPriorityZeroItemMenu: TMenuItem;
    SetPriorityMinus1ItemMenu: TMenuItem;
    SetPriorityMinus2ItemMenu: TMenuItem;
    SetPriorityMinus3ItemMenu: TMenuItem;
    BoardButtonToolBarPopupMenu: TPopupMenu;
    EditBoardButtonMenuItem: TMenuItem;
    N6: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    OpenAllCategoryAction: TAction;
    CloseAllCategoryAction: TAction;
    LogSweeperAction: TAction;
    GoTrayAction: TAction;
    TopicTabImageList: TImageList;
    TrayIcon: TTrayIcon;
    procedure StyleChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BoardListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure BoardListBoxData(Control: TWinControl; Index: Integer;
      var Data: String);
    procedure BoardListBoxClick(Sender: TObject);
    procedure TopicListViewData(Sender: TObject; Item: TListItem);
    procedure TopicListViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OpenNewTabMenuItemClick(Sender: TObject);
    procedure TopicTabControlChange(Sender: TObject);
    procedure TopicWriteToolButtonClick(Sender: TObject);
    procedure TopicTabControlDrawTab(Control: TCustomTabControl;
      TabIndex: Integer; const Rect: TRect; Active: Boolean);
    procedure CloseTabToolButtonClick(Sender: TObject);
    procedure TopicTabControlMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FavoriteToolButtonClick(Sender: TObject);
    procedure PatrolToolButtonClick(Sender: TObject);
    procedure BoardNameLabelClick(Sender: TObject);
    procedure AutoReloadMenuItemClick(Sender: TObject);
    procedure SearchToolButtonClick(Sender: TObject);
    procedure StopToolButtonClick(Sender: TObject);
    procedure TopicListViewColumnClick(Sender: TObject;
      Column: TListColumn);
    procedure MakeTopicToolButtonClick(Sender: TObject);
    procedure TopicTabControlResize(Sender: TObject);
    procedure OptionMenuItemClick(Sender: TObject);
    procedure TopicListViewDrawSubItem(Control: TWinControl;
      var ACanvas: TCanvas; Index, SubItem: Integer; ARect: TRect;
      State: TOwnerDrawState; var DefaultDrawing: Boolean);
    procedure TopicListViewDrawItem(Control: TWinControl;
      var ACanvas: TCanvas; Index: Integer; ARect: TRect;
      State: TOwnerDrawState; var DefaultDrawing, FullRowSelect: Boolean);
    procedure TrashToolButtonClick(Sender: TObject);
    procedure ViewLimitChangeClick(Sender: TObject);
    procedure TopicListViewCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure UpdateBoardListMenuItemClick(Sender: TObject);
    procedure UrlEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CopyUrlMenuItemClick(Sender: TObject);
    procedure CopyTitleUrlMenuItemClick(Sender: TObject);
    procedure OpenByBrowserMenuItemClick(Sender: TObject);
    procedure RepaintTabTimerTimer(Sender: TObject);
    procedure RepaintListViewTimerTimer(Sender: TObject);
    procedure DownloadAllTopicToolButtonClick(Sender: TObject);
    procedure RegisterBoardButtonMenuItemClick(Sender: TObject);
    procedure CopyBoardUrlMenuButtonClick(Sender: TObject);
    procedure OpenBoardByBrowserMenuItemClick(Sender: TObject);
    procedure CoolBarResize(Sender: TObject);
    procedure TopicTabControlMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LoginMenuItemClick(Sender: TObject);
    procedure ResAtMenuItemClick(Sender: TObject);
    procedure BoardListBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BoardButtonToolBarCustomized(Sender: TObject);
    procedure BoardDeleteMenuItemClick(Sender: TObject);
    procedure BoardButtonToolBarMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure CloseActiveTabActionExecute(Sender: TObject);
    procedure TabBeforeActionExecute(Sender: TObject);
    procedure TabForwardActionExecute(Sender: TObject);
    procedure ChangeLimitAllActiveTabExecute(Sender: TObject);
    procedure ChangeStyle2ActionExecute(Sender: TObject);
    procedure ChangeStyle1ActionExecute(Sender: TObject);
    procedure ChangeStyle3ActionExecute(Sender: TObject);
    procedure CreateOfflineFolderClick(Sender: TObject);
    procedure FavoritePopupMenuPopup(Sender: TObject);
    procedure FavoriteMenuItemClick(Sender: TObject);
    procedure RemoveOfflineFolderClick(Sender: TObject);
    procedure BoardListBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TopicTabControlMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure TopicTabControlDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure TopicTabControlDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure BoardListBoxDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure BoardListBoxDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SetPriorityMenuItemClick(Sender: TObject);
    procedure SetSelectedTopicPriority(Priority: Integer);
    procedure TopicListViewPopupMenuPopup(Sender: TObject);
    procedure TopicPagePopupMenuPopup(Sender: TObject);
    procedure SetPriorityPlusItemMenuClick(Sender: TObject);
    procedure EditBoardButtonMenuItemClick(Sender: TObject);
    procedure OpenAllCategoryActionExecute(Sender: TObject);
    procedure CloseAllCategoryActionExecute(Sender: TObject);
    procedure InputMemoMenuItemClick(Sender: TObject);
    procedure LogSweeperActionExecute(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure GoTrayActionExecute(Sender: TObject);
    procedure TrayIconMouseClick(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TopicListViewKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BoardListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CopyTitleUrlTopicListClick(Sender: TObject);
    procedure CopyUrlTopicListClick(Sender: TObject);

    procedure IETextSizeMenuItemClick(Sender: TObject);
    procedure Open2chGuideMenuItemClick(Sender: TObject);
    procedure Open2chMenuItemClick(Sender: TObject);
    procedure OpenByBrowserTopicListClick(Sender: TObject);
    procedure OpenKatju88SiteMenuItemClick(Sender: TObject);
    procedure OpenSupportBoardMenuItemClick(Sender: TObject);
    procedure SendMailMenuItemClick(Sender: TObject);
    procedure TrashMenuItemClick(Sender: TObject);
    procedure GoToToolButtonClick(Sender: TObject);
    procedure UrlEditChange(Sender: TObject);
    procedure AddressToolBarResize(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure URL3Click(Sender: TObject);
    procedure BoardButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BoardButtonClick(Sender: TObject);
    procedure ReceiveActiveTabActionExecute(Sender: TObject);
  private
    FActive          : boolean;
    FSelectButton    : string;
    FSelectMessageNo : integer;
    FOldtab        : TTopicBrowser;
    FWriteForm     : TWriteForm;
    FSelectedBoard : TBoard;
    FTopicList     : TList;
    FBrowserList   : TObjectList;
    FRefreshCount  : integer;
    FBoardListBoxItems : TObjectList;
    FBoardButtonList : TStringList;
    FBoardButtonMenuList : TObjectList;
    FRestoreCoolBands : Boolean;
    FTopicListSortOrder : boolean;
    FTopicListSortIndex : integer;
    FTopicListFilter    : string;
    FMouseControl: TControl;
    IsOpeningTopic: boolean;
    FImageList: TImageList;
    FListItemToClear: TObjectList;

    procedure OpenBoard(Board : TBoard);
    procedure OpenTab(Topic : TTopic; newtab : Boolean);
    procedure CloseTab(Index : integer);
    procedure ChangeTab();
    procedure Board_TopicReceived(Sender: TObject; Topic: TTopic);
    function  GetActiveTab : TTopicBrowser;
    procedure OpenUrl(Sender : TObject; Url : string);
    function  CreateTopicBrowser() : TTopicBrowser;
    procedure RefreshBoardListBox;
    procedure TopicBrowser_NavigateUrl(Sender : TObject; URL : string);
    procedure OpenBrowser(URL : string);
    procedure TopicBrowser_ChangeDownloadState(Sender : TObject);
    procedure CreateBoardButton();
    procedure SaveBoardButton;
    function  GetTabIndexAtPoint(Point : TPoint) : Integer;
    function  GetTabAtPoint(Point : TPoint) : TTopicBrowser;
    procedure FormIdle(Sender: TObject; var Done: Boolean);
    procedure OpenSelectedTopic;
    procedure BoardListViewSetVisible(const Visible, IsNormalMode : boolean);
    procedure TopicListViewSetVisible(const Visible, IsNormalMode : boolean);
    procedure BrowserPanelSetVisible(const Visible, IsNormalMode : boolean);
    procedure Spliter2SetVisible(const Visible, IsNormalMode : boolean);
    procedure ChangeTopicListViewColumnPadding;
  public
    { Public 錾 }
  end;
var
  MainForm: TMainForm;

implementation

uses
  untConfig;

{$R *.dfm}

{ TMainForm }

{ --------------------------------------------------------
  pr  : ^uύXꂽ
  l  : Ȃ
  ------------------------------------------------------ }
procedure TMainForm.ChangeTab;
var
  activeTab : TTopicBrowser;
  i         : integer;
  board     : TOnlineBoard;

begin
  activeTab := GetActiveTab();
  if activeTab = nil then
  begin
    exit;
  end;

  if (FOldtab <> nil) and (FOldTab <> ActiveTab) then
  begin
    FOldtab.ClearNewMsg;
  end;

  FOldtab := activeTab;

  if activeTab.Topic <> nil then
  begin
    board := TOnlineBoard(ActiveTab.Topic.Board);
    BoardNameLabel.Caption   := '[' + board.DisplayName + ']';
    TopicNameLabel.Left      := BoardNameLabel.Left + BoardNameLabel.Width + 5;
    TopicNameLabel.Caption   := ActiveTab.Topic.Title;
    activeTab.Caption        := TopicNameLabel.Caption;
    MainStatusBar.SimpleText := activeTab.Topic.StatusText;
    //AddressTextBox.Text  := activetab.Thread.BrowserUrl;

    if ActiveTab.Topic.IsFavorite then
    begin
      FavoriteToolButton.ImageIndex := 18;
    end else
    begin
      FavoriteToolButton.ImageIndex := 19;
    end;

    AutoReloadMenuItem.Checked := ActiveTab.AutoReload;

    UrlEdit.Text := ActiveTab.Topic.BrowserUrl;

  end else
  begin
    BoardNameLabel.Caption := '';
    TopicNameLabel.Caption := '';
    MainStatusBar.SimpleText := '';
  end;

  activeTab.Visible := true;
  for i := 0 to FBrowserList.Count - 1 do
  begin
    if FBrowserList[i] <> ActiveTab then
    begin
      TTopicBrowser(FBrowserList[I]).Visible := false;
    end;
  end;

  // ^uĕ`
  RepaintTabTimer.Enabled := true;
  //Application.ProcessMessages;
end;

{ --------------------------------------------------------
  pr  : {[hJ
  l  : Ȃ
  ------------------------------------------------------ }
procedure TMainForm.OpenBoard(Board: TBoard);
var
  doClear: Boolean;
  i, j: integer;
  category: TBoardCategory;
  subjectFile: string;
  fileStream: TFileStream;
  modifiedTime: TDateTime;

begin
  FRefreshCount := 0;
  FTopicListFilter := '';

  if FSelectedBoard is TOfflineBoard then
  begin
    TOfflineBoard(FSelectedBoard).Save;
  end;

  doClear := true;
  if Assigned(FSelectedBoard) and
     (FSelectedBoard = Board) and
     FSelectedBoard.IsDownloading then
  begin
    doClear := false;
  end;

  if doClear then
  begin
    TopicListView.Items.Clear();
    for i := 0 to FTopicList.Count -1 do
    begin
      gBBSCore.FreeTopic(TTopic(FTopicList[i]));
    end;
    gBBSCore.GC;
    FTopicList.Clear;
    FListItemToClear.Clear;
  end;

  if FSelectedBoard <> nil then
  begin
    FSelectedBoard.OnTopicReceived := nil;
    //FSelectedBoard.OnError := nil;
  end;

  // ^Cgo[ύX
  self.Caption := 'katju88kid Version ' + GetVersionStr();

  if Board <> nil then
  begin
    FSelectedBoard := Board;
    FSelectedBoard.OnTopicReceived := Board_TopicReceived;
    //FSelectedBoard.OnError := Board_TopicReceived;

    // VXmp
    if gConfig.TopicListColorUse and (FSelectedBoard is TOnlineBoard) then
    begin
      if not gFolderAlias.GetFolderPath(TOnlineBoard(FSelectedBoard).Server,
                                        TOnlineBoard(FSelectedBoard).BoardName,
                                        'subjects',
                                        subjectFile) then
      begin
        subjectFile := subjectFile + 'subjects';
      end;

      if FileExists(subjectFile) then
      begin
        FileStream := TFileStream.Create(subjectFile, fmOpenRead or fmShareDenyNone);
        modifiedTime := FileDateToDateTime(FileGetDate(FileStream.Handle));
        FileStream.Free;
        // datetime2unixtime
        // 32400 = 60 * 60 * 9 => JST=GMT+9  T[oɂĈႤ
        TOnlineBoard(FSelectedBoard).ModTime := Trunc((modifiedTime - EncodeDate(1970, 1, 1)) * 86400) - 32400;
      end;
    end;

    FSelectedBoard.Download();

    // ^Cgo[ύX
    self.Caption := self.Caption + ' [ ' + Board.DisplayName + ' ]';

    // {[hXg{bNX̑IύX
    for i := 0 to gBoardList.Categorys.Count - 1 do
    begin
      category := TBoardCategory(gBoardList.Categorys[I]);
      for j := 0 to category.Boards.Count - 1 do
      begin
        if category.Boards[j] = Board then
        begin
          if category.Opened = false then
          begin
            if gConfig.BoardListOneCategory then
            begin
              CloseAllCategoryActionExecute(nil);
            end;
            category.Opened := true;
            RefreshBoardListBox;
          end;
          break;
        end;
      end;
    end;

    for i := 0 to BoardListBox.Count - 1 do
    begin
      if TBoardListBoxItem(FBoardListBoxItems[i]).Board = Board then
      begin
        BoardListBox.Selected[i] := true;
        break;
      end;
    end;

    if FSelectedBoard is TOnlineBoard then
    begin
      UrlEdit.Text := TOnlineBoard(FSelectedBoard).BoardUrl;
    end;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  i: integer;
  activeTab: TTopicBrowser;
  items: TStringArray;
  item: TBoardListBoxItem;
begin
  // ꉞĂ݂ǕʂɕςȂ悤
  TimeBeginPeriod(1);

  FListItemToClear := TObjectList.Create;
  gBBSCore.DefaultTopicChangeDownloadStateFunction := TopicBrowser_ChangeDownloadState;

  FTopicList := TList.Create;
  FBoardListBoxItems := TObjectList.Create;

  // Style
  if gConfig.MainFormStyleType3 then
  begin
    StyleToolButton.ImageIndex := 3
  end else
  begin
    StyleToolButton.ImageIndex := 7;
  end;

  StyleSub1ToolButton.Down := gConfig.MainFormStyleSub1;
  StyleSub2ToolButton.Down := gConfig.MainFormStyleSub2;
  StyleSub3ToolButton.Down := gConfig.MainFormStyleSub3;

  // BoardList
  BoardListBox.ItemHeight := BoardListBox.Canvas.TextHeight('') + 2;

  // ݒ蔽f
  StyleChange(nil);
  OpenBoard(nil);
  TopicTabControl.MultiLine := gConfig.MultiLineTab;

  // TopicListViewColumn
  items := Split(gConfig.TopicListViewColumnOrders, ',');
  if Length(items) >= 11 then
  begin
    for I := 0 to 10 do
    begin
      TopicListView.Columns.FindItemID(StrToIntNeo(items[i])).Index := i;
    end;
  end;

  items := Split(gConfig.TopicListViewColumnWidths, ',');
  if Length(items) >= 11 then
  begin
    for i := 0 to 10 do
    begin
      TopicListView.Column[I].Width := StrToIntNeo(items[i]);
    end;
  end;

  TopicListView.Font.Size := gConfig.TopicListViewColumnFontSize;

  ChangeTopicListViewColumnPadding;

  TopicListView.GridLines := gConfig.TopicListViewGridLines;

  // {[hXgXV
  RefreshBoardListBox();

  FBrowserList := TObjectList.Create;

  // uEUЂƂJĂ
  activeTab := CreateTopicBrowser();
  activeTab.Visible := true;

  // ݃tH[
  FWriteForm := TWriteForm.Create(self);
  // [hp\bhݒ
  FWriteForm.ReloadTopic := ReceiveActiveTabActionExecute;

  // {^̍쐬
  FBoardButtonList := TStringList.Create;
  if FileExists(AppPath('favboard.idx')) then
    FBoardButtonList.LoadFromFile(AppPath('favboard.idx'));

  FBoardButtonMenuList := TObjectList.Create;
  CreateBoardButton();

  FRestoreCoolBands := true;

  // Form size
  self.Height := gConfig.MainFormHeight;
  self.Width  := gConfig.MainFormWidth;
  self.Top    := gConfig.MainFormTop;
  self.Left   := gConfig.MainFormLeft;
  self.Show;
  self.WindowState := TWindowState(gConfig.MainFormWindowState);

  //FRestoreCoolBands := true;
  //CoolBarResize(CoolBar);

  Application.OnIdle := FormIdle;

  // CɓJ
  item := TBoardListBoxItem(FBoardListBoxItems[1]);

  if item.Board <> nil then
  begin
    OpenBoard(item.Board)
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  i: Integer;
  column: TListColumn;
  band: TCoolBand;
begin

  if FSelectedBoard is TOfflineBoard then
  begin
    TOfflineBoard(FSelectedBoard).Save;
  end;

  FListItemToClear.Free;
  FWriteForm.Free;
  FBrowserList.Free;

  FBoardListBoxItems.Free;
  // Style
  gConfig.MainFormStyleType3 := (StyleToolButton.ImageIndex = 3);
  gConfig.MainFormStyleSub1  := StyleSub1ToolButton.Down;
  gConfig.MainFormStyleSub2  := StyleSub2ToolButton.Down;
  gConfig.MainFormStyleSub3  := StyleSub3ToolButton.Down;

  if LeftPanel.Visible then gConfig.BoardListBoxWidth := LeftPanel.Width;
  if (StyleToolButton.ImageIndex = 7) then
    if BrowserPanel.Visible then gConfig.TopicListViewHeight := TopicListView.Height
  else
    if BrowserPanel.Visible then gConfig.TopicListViewWidth := TopicListView.Width;

  // Form size
  if self.WindowState = wsMinimized then
    gConfig.MainFormWindowState := Integer(wsNormal)
  else
    gConfig.MainFormWindowState := Integer(self.WindowState);
  if self.WindowState = wsNormal then
  begin
    gConfig.MainFormHeight  := self.Height;
    gConfig.MainFormWidth   := self.Width;
    gConfig.MainFormTop     := self.Top;
    gConfig.MainFormLeft    := self.Left;
  end;

  // TopicListView column position
  gConfig.TopicListViewColumnOrders := '';
  gConfig.TopicListViewColumnWidths := '';
  for I := 0 to TopicListView.Columns.Count - 1 do
  begin
    column := TopicListView.Columns[i];
    gConfig.TopicListViewColumnOrders := gConfig.TopicListViewColumnOrders
                    + IntToStr(column.Tag) + ',';
    gConfig.TopicListViewColumnWidths := gConfig.TopicListViewColumnWidths
                    + IntToStr(column.Width) + ',';
  end;

  gConfig.CoolBarBandId    := '';
  gConfig.CoolBarBandWidth := '';
  gConfig.CoolBarBandBreak := '';
  for i := 0 to CoolBar.Bands.Count -1 do
  begin
    band := CoolBar.Bands[I];
    gConfig.CoolBarBandId    := gConfig.CoolBarBandId    + IntToStr(band.ID) + ', ' ;
    gConfig.CoolBarBandWidth := gConfig.CoolBarBandWidth + IntToStr(band.Width) + ', ';
    if band.Break = true then
      gConfig.CoolBarBandBreak := gConfig.CoolBarBandBreak + 'TRUE, '
    else
      gConfig.CoolBarBandBreak := gConfig.CoolBarBandBreak + 'FALSE, ';
  end;

  gBoardList.Save;

  //FBoardList.Free;
  FImageList.Free;
  FTopicList.Free;

  FBoardButtonMenuList.Free;
  FBoardButtonList.Free;

  TimeEndPeriod(1);
end;

function GetTopicStateNumber(Topic : TTopic) : Integer;
begin 
  if Topic.DownloadState <> dsNone  then
  begin
    Result := 0
  end else if Topic.IsFavorite then
  begin
    Result := 1
  end else if Topic.IsError then
  begin
    Result := 2
  end else if Topic.IsFreezed then
  begin
    Result := 3
  end else if (Topic.DatSize > 0) and
              (Topic.GotMessageCount >= Topic.MessageCount) then
  begin
    Result := 4
  end else if (Topic.DatSize > 0) and
              (Topic.GotMessageCount > 0) then
  begin
    Result := 5
  end else
  begin
    Result := -1;
  end;
end;

// \X^CύX
procedure TMainForm.StyleChange(Sender: TObject);
var 
  IsNormalMode : Boolean; 
begin 

  IsNormalMode := (StyleToolButton.ImageIndex = 7); 

  // yCX^C̕ύX 
  if Sender = StyleToolButton then 
  begin 
    if IsNormalMode then 
    begin
      StyleToolButton.ImageIndex     := 3; 
      StyleToolButton.Hint           := 'cRʍ\ɕύX'; 
      StyleSub1ToolButton.ImageIndex := 4; 
      StyleSub2ToolButton.ImageIndex := 5; 
      StyleSub3ToolButton.ImageIndex := 6; 
      gConfig.MainFormStyleType3            := True;
    end else
    begin
      StyleToolButton.ImageIndex     := 7;
      StyleToolButton.Hint           := 'ʏʍ\ɕύX';
      StyleSub1ToolButton.ImageIndex := 8; 
      StyleSub2ToolButton.ImageIndex := 9; 
      StyleSub3ToolButton.ImageIndex := 10; 
      gConfig.MainFormStyleType3            := False; 
    end; 
    IsNormalMode := (StyleToolButton.ImageIndex = 7); 
  end; 


  if StyleSub2ToolButton.Down and StyleSub3ToolButton.Down then 
    if(Sender = StyleSub2ToolButton) then 
      StyleSub3ToolButton.Down := false 
    else 
      StyleSub2ToolButton.Down := false;

  if StyleSub1ToolButton.Down then 
  begin 
    BoardListViewSetVisible(False, IsNormalMode); 
  end else 
  begin 
    BoardListViewSetVisible(True, IsNormalMode); 
  end; 

  if not StyleSub2ToolButton.Down and not StyleSub3ToolButton.Down then 
  begin 
    TopicListViewSetVisible(True, IsNormalMode); 
    Spliter2SetVisible(True, IsNormalMode); 
    BrowserPanelSetVisible(True, IsNormalMode); 
  end else 
  if StyleSub2ToolButton.Down then 
  begin 
    TopicListViewSetVisible(True, IsNormalMode); 
    Spliter2SetVisible(False, IsNormalMode); 
    BrowserPanelSetVisible(False, IsNormalMode); 
  end else // StyleSub3ToolButton.Down 
  begin 
    TopicListViewSetVisible(False, IsNormalMode); 
    Spliter2SetVisible(False, IsNormalMode);
    BrowserPanelSetVisible(True, IsNormalMode); 
  end; 


end;

// ꗗ`
procedure TMainForm.BoardListBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  ColorRect    : TRect;
  DefaultBrush : TColor;
  item         : TBoardListBoxItem;
begin

  if (index < 0) or (index >= FBoardListBoxItems.Count) then exit;

  item := TBoardListBoxItem(FBoardListBoxItems[Index]);

  // FÂ 
  if gConfig.BoardListNoColor = false then
  begin
    ColorRect.Left   := Rect.Left; 
    ColorRect.Top    := Rect.Top;
    ColorRect.Bottom := Rect.Bottom; 
    ColorRect.Right  := Rect.Left + 4; 
    DefaultBrush := TListBox(Control).Canvas.Brush.Color; 
    TListBox(Control).Canvas.Brush.Color := item.Category.Color; 
    TListBox(Control).Canvas.Brush.Style := bsSolid; 
    TListBox(Control).Canvas.FillRect(ColorRect); 
    TListBox(Control).Canvas.Brush.Color := DefaultBrush; 
  end;

  Rect.Left := Rect.Left + 4;
  TListBox(Control).Canvas.TextRect(Rect, Rect.Left + 1, Rect.Top + 1, item.ViewString);

  Rect.Left := Rect.Left - 4; 
  if odFocused in State then 
    TListBox(Control).Canvas.DrawFocusRect(Rect);

end;

// ^u`
procedure TMainForm.TopicTabControlDrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
var
  Browser  : TTopicBrowser;
  X        : Integer;
  DrawRect  : TRect;
begin

  if (TabIndex >= 0) and (TabIndex < TopicTabControl.Tabs.Count) then
  begin
    Browser := TTopicBrowser(FBrowserList[TabIndex]);

    // 
    Control.Canvas.FillRect(Rect);

    // ACR̕`
    if(Browser.ImageIndex > -1) and (Browser.ImageIndex < TopicTabControl.Images.Count) then
    begin
      TopicTabControl.Images.Draw(Control.Canvas, Rect.Left + 3, Rect.Top + 3, Browser.ImageIndex);

      X := Rect.Left + 20;
    end else
    begin
      X := Rect.Left + 5;
    end;

    if Active = false then
      Control.Canvas.Font.Color := clBtnShadow
    else
      Control.Canvas.Font.Color := clWindowText;

    DrawRect.Top    := Rect.Top + 2;
    DrawRect.Left   := X;
    DrawRect.Bottom := Rect.Bottom - 1;
    DrawRect.Right  := Rect.Right  - 1;
    Control.Canvas.TextRect(DrawRect, X, Rect.Top + 5, Browser.Caption);
  end;

end;

procedure TMainForm.BoardListBoxData(Control: TWinControl; Index: Integer;
  var Data: String);
var
  item     : TBoardListBoxItem;
begin

  if (index < 0) or (index >= FBoardListBoxItems.Count) then exit; 

  item := TBoardListBoxItem(FBoardListBoxItems[Index]);
  Data := item.ViewString;


end;


// {[hXgClick
procedure TMainForm.BoardListBoxClick(Sender: TObject);
var
  index: Integer;
  item: TBoardListBoxItem;
  isOpened: Boolean;
  i: Integer;
  categoryName: string;
begin
  index := BoardListBox.ItemIndex;

  if (index < 0) or (index >= FBoardListBoxItems.Count) then
  begin
    exit;
  end;

  item := TBoardListBoxItem(FBoardListBoxItems[index]);

  if item.Board <> nil then
  begin
    OpenBoard(item.Board)
  end else
  begin
    isOpened := item.Category.Opened;
    if gConfig.BoardListOneCategory then
    begin
      categoryName := Item.Category.CategoryName;
      CloseAllCategoryActionExecute(Sender);
      for i := 0 to FBoardListBoxItems.Count - 1 do
        if TBoardListBoxItem(FBoardListBoxItems[i]).Category.CategoryName = CategoryName then
        begin
          item  := TBoardListBoxItem(FBoardListBoxItems[i]);
          index := i;
        end;
    end;
    item.Category.Opened   := not IsOpened;
    BoardListBox.ItemIndex := index;
    RefreshBoardListBox;
  end;
end;

procedure TMainForm.TopicListViewData(Sender: TObject; Item: TListItem);
var
  topic: TTopic;
  gotmsg: string;
  newmsg: string;

begin
  if (Item.Index < 0) or (Item.Index >= FTopicList.Count) then
  begin
    exit;
  end;

  topic := TTopic(FTopicList[Item.Index]);

  gotmsg := IntToStr(topic.GotMessageCount);
  if topic.GotMessageCount <= 0 then
  begin
    gotmsg := '';
  end;

  newmsg := IntToStr(topic.NewMessageCount);
  if (topic.NewMessageCount <= 0) then
  begin
    newmsg := '';
  end;

  Item.Caption  := '';
  if topic.Priority < 0 then
  begin
    Item.SubItems.Add(IntToStr(Topic.Priority))
  end else if topic.Priority > 0 then
  begin
    Item.SubItems.Add('+' + IntToStr(Topic.Priority))
  end else
  begin
    Item.SubItems.Add('');
  end;
  Item.SubItems.Add(IntToStr(topic.Index));

  Item.SubItems.Add(topic.Title);
  Item.SubItems.Add(IntToStr(topic.MessageCount));
  Item.SubItems.Add(gotmsg);
  Item.SubItems.Add(newmsg);
  Item.SubItems.Add(topic.LastReadDate);
  Item.SubItems.Add(topic.LastWriteDate);

  if topic.Board <> nil then
  begin
    Item.SubItems.Add(TBoard(topic.Board).DisplayName)
  end else
  begin
    Item.SubItems.Add('');
  end;

  Item.SubItems.Add(topic.Memo);

  // ACR
  Item.ImageIndex := GetTopicStateNumber(topic);
end;

procedure TMainForm.TopicListViewCustomDrawItem(Sender: TCustomListView;
                                                Item: TListItem;
                                                State: TCustomDrawState;
                                                var DefaultDraw: Boolean);
var
  color: TColor;
  imgindex: Integer;
  topic: TTopic;
  
begin
  DefaultDraw := true;

  if gConfig.TopicListColorUse = false then
    exit;

  color := clBlack;

  if gConfig.TopicListColorUse then
  begin

    imgindex := Item.ImageIndex;
    if Item <> nil then
    begin
      topic := TTopic(FTopicList[Item.Index]);

      if imgindex = 1 then
      begin
        if (topic.DatSize > 0) and (topic.GotMessageCount < topic.MessageCount) then
          imgindex := 5;
      end;
    end;

    case imgindex of
     -1:
        color := gConfig.TopicListNotGotColor;
      1:
        color := gConfig.TopicListFavoriteColor;
      4:
        color := gConfig.TopicListNoNewMesColor;
      5:
        color := gConfig.TopicListNewMesColor;
    end;
  end;
  TopicListView.Canvas.Font.Color := Color;
end;

// gsbNACeIꂽ
procedure TMainForm.TopicListViewMouseUp(Sender: TObject;
                                         Button: TMouseButton;
                                         Shift: TShiftState;
                                         X, Y: Integer);
begin
  if Button = mbLeft then
    OpenSelectedTopic();
end;

// ^uύX
procedure TMainForm.TopicTabControlChange(Sender: TObject);
begin
  ChangeTab();
end;

// ^u_uNbNꂽ
procedure TMainForm.TopicTabControlMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

  if (Button = mbLeft) and (ssDouble in Shift) then
    OpenSelectedTopic; 

  if Button = mbLeft then
    TopicTabControl.BeginDrag(false, 8);
  
end;

procedure TMainForm.TopicTabControlMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbMiddle then
    CloseTabToolButtonClick(nil);
end;

// xNbN
procedure TMainForm.BoardNameLabelClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetActiveTab();
  if Assigned(ActiveTab) and Assigned(ActiveTab.Topic) then
  begin
    OpenBoard(TBoard(ActiveTab.Topic.Board));
  end;
end;

function TopicListSortCompare(Item1, Item2: Pointer): Integer;
var
  Compare        : integer;
  Topic1, Topic2 : TTopic;
  NoChange       : boolean;
begin

  Topic1 := Item1;
  Topic2 := Item2;
  nochange := false;
  Compare  := 0;

  case MainForm.FTopicListSortIndex  of
  0: Compare := CompareValue  (GetTopicStateNumber(Topic1), GetTopicStateNumber(Topic2));
  1: Compare := CompareValue  (Topic1.Priority,        Topic2.Priority);  
  2: Compare := CompareValue  (Topic1.Index,           Topic2.Index);
  3: Compare := AnsiCompareStr(Topic1.Title,           Topic2.Title);
  4: Compare := CompareValue  (Topic1.MessageCount,    Topic2.MessageCount);
  5: Compare := CompareValue  (Topic1.GotMessageCount, Topic2.GotMessageCount);
  6: Compare := CompareValue  (Topic1.NewMessageCount, Topic2.NewMessageCount);
  7: Compare := AnsiCompareStr(Topic1.LastReadDate,    Topic2.LastReadDate);
  8: Compare := AnsiCompareStr(Topic1.LastWriteDate,   Topic2.LastWriteDate);
  9: Compare := AnsiCompareStr(TBoard(Topic1.Board).DisplayName, TBoard(Topic2.Board).DisplayName);
  else nochange := true;
  end;
  if MainForm.FTopicListSortOrder = true then Compare:=-Compare;
  if nochange then
    Compare := CompareValue(Topic1.Index, Topic2.Index);

  result := Compare;
end;

// Xgr[\[g
procedure TMainForm.TopicListViewColumnClick(Sender: TObject;
  Column: TListColumn);
begin

  if Column.Index = FTopicListSortIndex then
  begin
    FTopicListSortOrder := not FTopicListSortOrder
  end else
  begin
    FTopicListSortOrder := true;
    FTopicListSortIndex := Column.id;
  end;
  FTopicList.Sort(TopicListSortCompare);

  // Xbhqɂ̒g̃\[g
  if FSelectedBoard is TOfflineBoard then
  begin
    TOfflineBoard(FSelectedBoard).Sort(TopicListSortCompare);
  end;

  TopicListView.Repaint;
end;

// OpenURL
procedure TMainForm.UrlEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if Key = $0d then
    OpenUrl(Sender, UrlEdit.Text);

end;

//  j[Cxg 

// ݒEBhEJ
procedure TMainForm.OptionMenuItemClick(Sender: TObject);
var
  OptionForm  : TOptionForm;
  oldpadding  : integer;
  oldfontsize : integer;
begin

  oldpadding  := gConfig.TopicListViewColumnPadding;
  oldfontsize := gConfig.TopicListViewColumnFontSize;

  OptionForm := TOptionForm.Create(self);
  OptionForm.ShowModal;
  OptionForm.Free;

  if oldpadding <> gConfig.TopicListViewColumnPadding then
    ChangeTopicListViewColumnPadding;

  if oldfontsize <> gConfig.TopicListViewColumnFontSize then
    TopicListView.Font.Size := gConfig.TopicListViewColumnFontSize;

end;

// {[hXg̍XV
procedure TMainForm.UpdateBoardListMenuItemClick(Sender: TObject);
var
  UpdateBoardForm : TUpdateBoardListForm;
begin

  UpdateBoardForm := TUpdateBoardListForm.Create(self);
  UpdateBoardForm.ShowModal;
  UpdateBoardForm.Free;

  RefreshBoardListBox;

end;

// OC
procedure TMainForm.LoginMenuItemClick(Sender: TObject);
var
  LoginForm : TLoginForm;
begin

  LoginForm := TLoginForm.Create(self);
  LoginForm.ShowModal;
  LoginForm.Release;
  LoginForm.Free;

end;

// open topic with newtab
procedure TMainForm.OpenNewTabMenuItemClick(Sender: TObject);
var
  topic : TTopic;
  item  : TListItem;
  isNewTab : Boolean;

begin
  if not IsOpeningTopic then
  begin
    IsOpeningTopic := True;

    item := TopicListView.Selected;
    if item <> nil then
    begin
      isNewTab := not gConfig.AlwaysNewTab;
      topic := FTopicList[item.Index];
      OpenTab(topic, IsNewTab);
    end;

    IsOpeningTopic := False;
  end;
end;

// I[g[h
procedure TMainForm.AutoReloadMenuItemClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  AutoReloadMenuItem.Checked := not AutoReloadMenuItem.Checked;

  ActiveTab := GetTabAtPoint(TopicPagePopupMenu.PopupPoint);
  if ActiveTab <> nil then
    if ActiveTab.Topic <> nil then
      ActiveTab.AutoReload := AutoReloadMenuItem.Checked;
end;

procedure TMainForm.ViewLimitChangeClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetActiveTab();
  if ActiveTab = nil then
  begin
    exit;
  end;

  if Sender = ViewLimit50MenuItem then
  begin
    ActiveTab.ChangeViewLimit(50);
  end
  else if Sender = ViewLimit100MenuItem then
  begin
   ActiveTab.ChangeViewLimit(100);
  end
  else if Sender = ViewLimit250MenuItem then
  begin
    ActiveTab.ChangeViewLimit(250);
  end
  else if Sender = ViewLimit500MenuItem then
  begin
    ActiveTab.ChangeViewLimit(500);
  end
  else if Sender = ViewLimit1000MenuItem then
  begin
    ActiveTab.ChangeViewLimit(1000);
  end
  else
  begin
    ActiveTab.ChangeViewLimit(0);
  end;
  ChangeTab;
end;

//  c[j[Cxg 

// Jn
procedure TMainForm.PatrolToolButtonClick(Sender: TObject);
begin
  if FSelectedBoard <> gBoardList.FavoriteBoard then
  begin
    OpenBoard(gBoardList.FavoriteBoard);
  end;
  gBoardList.FavoriteBoard.Patrol();
  RepaintListViewTimer.Enabled := true;
end;

// 
procedure TMainForm.SearchToolButtonClick(Sender: TObject);
var
  i            : Integer;
  searchText   : string;
  activeTab    : TTopicBrowser;
  newTopicList : TList;
begin

  SearchForm.ShowModal;
  searchText := SearchForm.SearchEdit.Text;

  if SearchForm.SearchSelect = srFromTopic then
  begin

    // gsbN̓e猟
    activeTab := GetActiveTab();
    if activeTab <> nil then
      activeTab.SearchText(searchText);
  end
  else if SearchForm.SearchSelect = srFromTopicList then
  begin
    // gsbNXg猟
    FTopicListFilter := searchText;
    newTopicList := TList.Create;
    for i := 0 to FTopicList.Count - 1 do
      if AnsiContainsText(TTopic(FTopicList[I]).Title, searchText) then
        newTopicList.Add(FTopicList[i]);

    FTopicList.Free;
    FTopicList := newTopicList;
    TopicListView.Items.Count := FTopicList.Count;
    TopicListView.Repaint;
  end
  else if SearchForm.SearchSelect = srFromBoardList then
  begin

    // {[hXg猟
    for I := 0 to BoardListBox.Count - 1 do
      if AnsiContainsText(BoardListBox.Items[I], SearchText) then

      begin
        BoardListBox.Selected[I] := true;
        //BoardListBox.ItemIndex := I;
        BoardListBoxClick(BoardListBox);
        break;
      end;
  end;

end;

// gsbN
procedure TMainForm.TopicWriteToolButtonClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetActiveTab();
  if ActiveTab <> nil then
  begin
    if ActiveTab.Topic <> nil then
    begin
      FWriteForm.SetTopic(ActiveTab.Topic);
    end;
  end;
end;

// ɃX
procedure TMainForm.ResAtMenuItemClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetActiveTab();
  if ActiveTab <> nil then
    if ActiveTab.Topic <> nil then
      FWriteForm.SetTopic(ActiveTab.Topic, FSelectMessageNo);
      
end;

// O̍폜
procedure TMainForm.TrashToolButtonClick(Sender: TObject);
var
  ActiveTab: TTopicBrowser;
  deleteTopic: TTopic;
begin

  ActiveTab := GetActiveTab();
  if ActiveTab <> nil then
  begin
    // CloseTopicActiveTab.TopicnilɂȂ̂
    deleteTopic := ActiveTab.Topic;
    ActiveTab.CloseTopic;
    deleteTopic.EraseLog;
    gBBSCore.FreeTopic(deleteTopic);
    // \XV
    if FSelectedBoard is TOfflineBoard then
    begin
      FTopicList.Clear;
      FListItemToClear.Clear;
      FSelectedBoard.Download;
    end;
  end;
  ChangeTab();
end;

// ^u
procedure TMainForm.CloseTabToolButtonClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
  I         : Integer;
  Found     : Boolean;
  Index     : Integer;
  PT : TPoint;
begin

  //TopicTabControl.DoubleBuffered := true;
  //TopicTabControl.SelectNextPage(false);
  ActiveTab := GetTabAtPoint(TopicPagePopupMenu.PopupPoint);

  //TopicTabControl.Pages.RemoveControl(TopicTabControl.ActivePage);

  if Sender = CloseMenuItem then 
  begin
  
    Index := GetTabIndexAtPoint(TopicPagePopupMenu.PopupPoint); 
    CloseTab(Index);

  end else
  if Sender = CloseAllMenuItem then
  begin

    // Sĕ
    for I := 0 to TopicTabControl.Tabs.Count - 1 do
      CloseTab(0);

  end else
  if Sender = CloseWithoutMenuItem then
  begin

    // ANeBuȃ^uȊO
    Found := false;
    for I := 0 to TopicTabControl.Tabs.Count - 1 do
      if Found = false then
        if FBrowserList[0] <> ActiveTab then
          CloseTab(0)
        else
          Found := true
      else
        CloseTab(1);

  end else
  if Sender = nil then
  begin

    // {^NbN^u
    GetCursorPos(PT);
    Index := GetTabIndexAtPoint(PT);
    CloseTab(Index);
  end else

    // ANeBuȃ^u
    CloseTab(TopicTabControl.TabIndex);


  //TopicTabControl.DoubleBuffered := false;

end;

// SẴgsbN_E[h
procedure TMainForm.DownloadAllTopicToolButtonClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
  I         : Integer;
begin

  for I := 0 to FBrowserList.Count - 1 do
  begin
    ActiveTab := TTopicBrowser(FBrowserList[I]);
    ActiveTab.Reload;
  end;

  RepaintTabTimer.Enabled := true;
  
end;

// Cɓɒǉ
procedure TMainForm.FavoriteToolButtonClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
  
begin
  ActiveTab := GetActiveTab();
  if ActiveTab <> nil then
  begin
    if ActiveTab.Topic <> nil then
    begin
      if not ActiveTab.Topic.IsFavorite then
      begin
        ActiveTab.Topic.IsFavorite := true;
        gBoardList.FavoriteBoard.AppendTopic(ActiveTab.Topic);
      end else
      begin
        ActiveTab.Topic.IsFavorite := false;
        gBoardList.FavoriteBoard.RemoveTopic(ActiveTab.Topic);
      end;
    end;
    TopicBrowser_ChangeDownloadState(ActiveTab.Topic);
    if FSelectedBoard is TOfflineBoard then
    begin
      // \XV
      FTopicList.Clear;
      FListItemToClear.Clear;
      FSelectedBoard.Download;
    end;
  end;
end;

// _E[h~
procedure TMainForm.StopToolButtonClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetActiveTab();
  if ActiveTab <> nil then
  begin
    if ActiveTab.Topic <> nil then
    begin
      // 
    end;
  end;
end;

// gsbN̍쐬
procedure TMainForm.MakeTopicToolButtonClick(Sender: TObject);
begin

  if FSelectedBoard <> nil then
    if FSelectedBoard is TOnlineBoard then
      FWRiteForm.SetBoard(TOnlineBoard(FSelectedBoard));

end;

// URL̃Rs[
procedure TMainForm.CopyUrlMenuItemClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetTabAtPoint(TopicPagePopupMenu.PopupPoint);
  if ActiveTab <> nil then
    if ActiveTab.Topic <> nil then
      Clipboard.AsText := ActiveTab.Topic.BrowserUrl;

end;

// ^CgURL̃Rs[
procedure TMainForm.CopyTitleUrlMenuItemClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetTabAtPoint(TopicPagePopupMenu.PopupPoint);
  if ActiveTab <> nil then
    if ActiveTab.Topic <> nil then
      Clipboard.AsText := ActiveTab.Topic.Title + #13#10 +
                          ActiveTab.Topic.BrowserUrl;

end;

// uEUŊJ
procedure TMainForm.OpenByBrowserMenuItemClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetTabAtPoint(TopicPagePopupMenu.PopupPoint);
  if ActiveTab <> nil then
  begin
    if ActiveTab.Topic <> nil then
    begin
      OpenBrowser(ActiveTab.Topic.BrowserUrl);
    end;
  end;
end;

procedure TMainForm.BoardListBoxMouseUp(Sender: TObject;
                                        Button: TMouseButton;
                                        Shift: TShiftState;
                                        X, Y: Integer);
var
  index: integer;
  pos: TPoint;
  item: TBoardListBoxItem;
  boardName: string;
begin

  if Button = mbRight then
  begin
    pos.X := x;
    pos.Y := y;
    index := BoardListBox.ItemAtPos(pos, true);
    if index < 0 then
    begin
      index := BoardListBox.Count - 1;
    end;
    BoardListBox.ItemIndex := index;

    // {^
    item := TBoardListBoxItem(FBoardListBoxItems[index]);
    if item.Board <> nil then
    begin
      boardName := TBoard(item.Board).DisplayName
    end else
    begin
      boardName := '' + item.Category.CategoryName;
    end;

    // o^Ă΃`FbN
    if FBoardButtonList.IndexOf(boardName) = -1 then
    begin
      RegisterBoardButtonMenuItem.Checked := false
    end else
    begin
      RegisterBoardButtonMenuItem.Checked := true;
    end;

    // }CtH_ȂAXbhqɍ쐬j[\
    if boardName = '}CtH_' then
    begin
      CreateOfflineFolder.Visible := true
    end else
    begin
      CreateOfflineFolder.Visible := false;
    end;

    // XbhqɂȂ폜j[\
    RemoveOfflineFolder.Visible := false;
    if (item.Board <> nil) and
       (item.Board is TOfflineBoard) and
       (item.Board.DisplayName <> 'Cɓ') then
    begin
      RemoveOfflineFolder.Visible := true;
    end;

    {ۂ̔ȊÓuURLRs[vuuEUŊJv\}
    CopyBoardUrlMenuButton.Visible     := True;
    OpenBoardByBrowserMenuItem.Visible := True;
    if not (item.Board is TOnlineBoard) then
    begin
      CopyBoardUrlMenuButton.Visible     := False;
      OpenBoardByBrowserMenuItem.Visible := False;
    end;

    BoardListBoxPopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
  end else if button = mbLeft then
  begin
    BoardListBoxClick(BoardListBox);
  end;
end;

procedure TMainForm.RegisterBoardButtonMenuItemClick(Sender: TObject);
var
  Index     : Integer;
  item      : TBoardListBoxItem;
  itemind   : integer;
  boardname : string;
begin

  Index := BoardListBox.ItemIndex;
  if (index < 0) or (index >= FBoardListBoxItems.Count) then
    exit;

  item := TBoardListBoxItem(FBoardListBoxItems[Index]);
  if item.Board <> nil then
    boardname := TBoard(item.Board).DisplayName
  else
    boardname := '' + item.Category.CategoryName;

  // o^ĂȂΓo^
  itemind := FBoardButtonList.IndexOf(boardname);
  if itemind = -1 then
    FBoardButtonList.Add(boardname) 
  else
    FBoardButtonList.Delete(itemind); 

  CreateBoardButton;
  SaveBoardButton;

end;

// {^̃JX^}CY
procedure TMainForm.BoardDeleteMenuItemClick(Sender: TObject);
var
  itemind : integer;
begin

  // o^Ă΍폜
  itemind := FBoardButtonList.IndexOf(FSelectButton);
  if itemind > -1 then
    FBoardButtonList.Delete(itemind); 

  CreateBoardButton;
  SaveBoardButton;

end;

procedure TMainForm.BoardButtonToolBarMouseUp(Sender: TObject; 
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin 
  // TToolButton(Sender).Down := false;

  //
  if (Sender is TToolButton) and (Button = mbRight) then
  begin
    FSelectButton := TToolButton(Sender).Caption;
    BoardButtonPopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
  end;
  if (Sender is TToolBar) and (Button = mbRight) then
    BoardButtonToolBarPopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y); 
end;

procedure TMainForm.CopyBoardUrlMenuButtonClick(Sender: TObject);
var
  Index    : Integer;
  item     : TBoardListBoxItem;
begin

  Index := BoardListBox.ItemIndex;
  if (index < 0) or (index >= FBoardListBoxItems.Count) then exit;

  item := TBoardListBoxItem(FBoardListBoxItems[Index]);
  if item.Board <> nil then
    if item.Board is TOnlineBoard then
      Clipboard.AsText := TOnlineBoard(item.Board).BoardUrl;

end;

procedure TMainForm.OpenBoardByBrowserMenuItemClick(Sender: TObject);
var
  Index    : Integer;
  item     : TBoardListBoxItem;
begin

  Index := BoardListBox.ItemIndex;
  if (index < 0) or (index >= FBoardListBoxItems.Count) then exit;

  item := TBoardListBoxItem(FBoardListBoxItems[Index]);
  if item.Board <> nil then
    if item.Board is TOnlineBoard then
      OpenBrowser(TOnlineBoard(item.Board).BoardUrl);
      
end;

//  ̑̃Cxg 

// gsbNM
procedure TMainForm.Board_TopicReceived(Sender: TObject; Topic: TTopic);
begin
  if Application.Terminated then
  begin
    exit;
  end;

  if (FTopicListFilter <> '') and
     not AnsiContainsText(Topic.Title, FTopicListFilter) then
  begin
      exit;
  end;

  FTopicList.Add(Topic);
  FListItemToClear.Add(TopicListView.Items.Add);

  // ܂ɍĕ`悵Ă݂
  Inc(FRefreshCount);
  if FRefreshCount = 20 then
  begin
    TopicListView.DoubleBuffered := true;
    TopicListView.Repaint;
    TopicListView.DoubleBuffered := false;
  end;

  Application.ProcessMessages;
end;

//  vCx[g֐ 

{ --------------------------------------------------------
  ֐: CloseTab
  pr  : ^u
    : Tab - ^u
  ߂l: Ȃ
  l  : Ȃ
  ------------------------------------------------------ }
procedure TMainForm.CloseTab(Index : integer);
var
  tab : TTopicBrowser;
  select : integer;
  closedTabIndex : Integer;
begin

  if (index >= 0) and (index < FBrowserList.Count) then
  begin
    tab := TTopicBrowser(FBrowserList[index]);

    if TopicTabControl.Tabs.Count = 1 then
      tab.CloseTopic
    else
    begin
      closedTabIndex := TopicTabControl.TabIndex;

      tab.SaveScrollPosition;
      TopicTabControl.Tabs.Delete(index);
      TopicTabControl.RemoveControl(tab);
      FBrowserList.Remove(tab);

      if closedTabIndex = index then
      begin
        if index > 1 then select := index - 1 else select := 0;
        TopicTabControl.TabIndex := select;
      end;
    end;
    FOldtab := nil;

    ChangeTab();
  end;
end;

{ --------------------------------------------------------
  pr  : gsbN^uŊJ
  l  : Ȃ
  ------------------------------------------------------ }
procedure TMainForm.OpenTab(topic: TTopic; newtab: Boolean);
var
  match       : Boolean;
  activeTab   : TTopicBrowser;
  i           : Integer;
  browser     : TTopicBrowser;
  selectindex : integer;
  opennewtab  : boolean;

  procedure Change(const selectindex: integer);
  begin
    TopicTabControl.TabIndex := selectindex;
    Application.ProcessMessages;
  end;

begin
  // ɃXbh\ς݂Ȃ炻ANeBuɂ
	match := false;
	activetab := nil;
  selectindex := 0;
  for I := 0 to TopicTabControl.Tabs.Count - 1 do
  begin
    browser := TTopicBrowser(FBrowserList[I]);
    if browser.Topic = topic then
    begin
		  activetab := browser;
      match := true;
      selectindex := i;
			break;
    end;
  end;

  if match then
  begin
    // [hJn
    Change(selectindex);
    activetab.Reload();
  end else
  begin
    if (TTopicBrowser(FBrowserList[0]).Topic <> nil) and newtab then
    begin
      opennewtab := true;
    end else
    begin
      opennewtab := false;

		  activeTab := GetActiveTab();
      if activeTab.AutoReload then
      begin
        opennewtab := true;
      end;
    end;

    if opennewtab then
    begin
      // VJ
  	  activeTab := CreateTopicBrowser();
      selectindex := FBrowserList.Count - 1;
      Change(selectindex);
      activeTab.OpenTopic(topic);
    end else
    begin
      // ANeBuȃ^uŊJ
      if activeTab = nil then
      begin
        exit;
      end;
      selectindex := TopicTabControl.TabIndex;
      Change(selectindex);
      activetab.OpenTopic(topic);
    end;
  end;
  ChangeTab();
end;


{ --------------------------------------------------------
  ֐: GetActiveTab
  pr  : ANeBuȃ^u擾
    : Ȃ
  ߂l: Ȃ
  l  : Ȃ
  ------------------------------------------------------ }
function TMainForm.GetActiveTab: TTopicBrowser;
var
  index : integer;
begin

  index := TopicTabControl.TabIndex;
  if (index >= 0) and (index < FBrowserList.Count) then
  begin
    result := TTopicBrowser(FBrowserList[index])
  end else
  begin
    result := nil;
  end;
end;

procedure TMainForm.TopicTabControlResize(Sender: TObject);
var
  I : Integer;
  tab : TTopicBrowser;
begin

  if FBrowserList <> nil then
    for I := 0 to FBrowserList.Count - 1 do
    begin
      tab       := TTopicBrowser(FBrowserList[I]);
      tab.Left  := 3;
      tab.Top   := TopicTabControl.TabHeight * TopicTabControl.RowCount + 5;
      tab.Width := TopicTabControl.Width - 6;
      tab.Height:= TopicTabControl.Height - tab.Top - 3;
    end;

end;

procedure TMainForm.TopicListViewDrawSubItem(Control: TWinControl;
  var ACanvas: TCanvas; Index, SubItem: Integer; ARect: TRect;
  State: TOwnerDrawState; var DefaultDrawing: Boolean);
begin

  //ACanvas.Font.Color := clHighlight;
  //ACanvas.TextRect(ARect, AREct.Top , Arect.Left , 'test');
  DefaultDrawing := true;
end;

procedure TMainForm.TopicListViewDrawItem(Control: TWinControl;
                                          var ACanvas: TCanvas;
                                          Index: Integer;
                                          ARect: TRect;
                                          State: TOwnerDrawState;
                                          var DefaultDrawing, FullRowSelect: Boolean);
begin
  DefaultDrawing := true;
end;

// URLJ
procedure TMainForm.OpenUrl(Sender : TObject; Url: string);
var
  parser: T2chUrlParser;
  topic: TTopic;
  board: TOnlineBoard;
  navigated: boolean;
  msgno: integer;
  isNewTab : Boolean;
begin

  navigated := false;

  if AnsiStartsStr('menu://at/', URL) then
  begin
    msgno := StrToIntNeo(CopyAfter(URL, 11));
    FSelectMessageNo := msgno;
    ArticlePopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
    exit;
  end;

  parser := T2chUrlParser.Create(Url);
  if parser.Is2chUrl then
  begin
    board := gBoardList.GetBoard(parser.Host, parser.BoardName, true);
    if board <> nil then
      if parser.TopicId <> '' then
      begin
        topic := gBBSCore.GetTopic(board, parser.TopicId);

        if topic.NoIndex = true then
        begin
          gBBSCore.DownloadBoard(board);
          Application.ProcessMessages;
        end;

        if Sender is TEdit then
        begin
          isNewTab := (GetAsyncKeyState(VK_SHIFT) < 0) xor gConfig.AlwaysNewTab;
          OpenTab(topic, IsNewTab);
        end else
        begin // if Sender is TTopicBrowser
          OpenTab(topic, True);
        end;
        navigated := true;
      end else
      begin
        OpenBoard(board);
        navigated := true;
      end;
  end;
  parser.Free;

  // uEUŊJ
  if navigated = false then
    OpenBrowser(Url);
end;

function TMainForm.CreateTopicBrowser: TTopicBrowser;
begin

  if gConfig.BrowserType = ubDoe then
  begin
    result := TTopicBrowserDoe.Create(self)
  end else
  begin
    result := TTopicBrowserIE.Create(self);
  end;

  result.OnChangeDownloadState := TopicBrowser_ChangeDownloadState;
  result.Visible := false;
  result.Parent  := TopicTabControl;
  result.OnNavigateUrl := TopicBrowser_NavigateUrl;
  FBrowserList.Add(result);
  TopicTabControl.Tabs.Add('');

end;

// {[hꗗ̍č\z
procedure TMainForm.RefreshBoardListBox;
var 
  i, j        : Integer; 
  c_Category  : TBoardCategory;
  newitem     : TBoardListBoxItem;
  selectindex : integer; 
  menuitem    : TMenuItem; 
  numOfShowItems    : Integer; 
  categoryName      : string; 
  numOfChildBoards  : Integer; 
  newTopIndex       : Integer;
  oldTopIndex       : Integer;
begin

  numOfShowItems    := BoardListBox.Height div BoardListBox.ItemHeight; 
  selectindex       := BoardListBox.ItemIndex;
  categoryName      := BoardListBox.Items[BoardListBox.ItemIndex]; 
  categoryName      := Copy(categoryName, 3, Length(categoryName) - 1);
  numOfChildBoards  := 0; 

  oldTopIndex := BoardListBox.TopIndex;
  FBoardListBoxItems.Clear;

  Application.ProcessMessages;

  for i := 0 to gBoardList.Categorys.Count - 1 do
  begin
    c_Category := TBoardCategory(gBoardList.Categorys[I]);

    newitem    := TBoardListBoxItem.Create;
    if c_Category.Opened then
      newitem.ViewString := '' + C_Category.CategoryName
    else
      newitem.ViewString := '' + C_Category.CategoryName;
    newitem.Category   := C_Category;
    newitem.Board      := nil;
    FBoardListBoxItems.Add(newitem);

    if c_Category.Opened = true then
      for j := 0 to C_Category.Boards.Count - 1 do
      begin
        newitem := TBoardListBoxItem.Create;
        newitem.ViewString := '@' + TBoard(C_Category.Boards[J]).DisplayName;
        newitem.Category   := C_Category;
        newitem.Board      := TBoard(C_Category.Boards[J]);
        FBoardListBoxItems.Add(newitem);
        if categoryName = C_Category.CategoryName then
          Inc(numOfChildBoards);
      end;
  end;

  BoardListBox.Count := FBoardListBoxItems.Count;
  BoardListBox.ItemIndex := selectindex;
  newTopIndex := oldTopIndex; 

  // scroll to opened category
  if (numOfChildBoards > 0) then
  begin
    // if not enough space
    if numOfChildBoards > numOfShowItems then
    begin
      newTopIndex := selectIndex;
    end
    else if (((selectindex - newTopIndex) + numOfChildBoards + 3) > numOfShowItems) then
    begin
      newTopIndex := (selectindex + numOfChildBoards + 2) - numOfShowItems;
    end;
  end;

  BoardListBox.TopIndex := newTopIndex;

  FavoritePopupMenu.Items.Clear;
  for i := 1 to gBoardList.MyFolder.Boards.Count - 1 do 
  begin
    if not (TBoard(gBoardList.MyFolder.Boards[I]) is TOfflineBoard) then continue;  
    menuitem := TMenuItem.Create(FavoritePopupMenu);
    menuitem.Caption := TBoard(gBoardList.MyFolder.Boards[I]).DisplayName; 
    menuitem.OnClick := FavoriteMenuItemClick; 
    menuitem.Tag     := I; 
    FavoritePopupMenu.Items.Add(menuitem); 
  end; 
end;

procedure TMainForm.TopicBrowser_NavigateUrl(Sender: TObject; URL: string);
begin
  OpenUrl(Sender, URL);
end;

procedure TMainForm.OpenBrowser(URL: string);
begin
  URL := AnsiReplaceText(URL, '[%23]', '#');

  if gConfig.UseDefaultBrowser or (gConfig.BrowserPath = '') then
  begin
    ShellExecute(Handle, 'OPEN', pchar('URL:' + URL),'', '', SW_SHOWNORMAL)
  end else
  begin
    ShellExecute(Handle, 'OPEN', PChar(gConfig.BrowserPath), pchar(URL), '', SW_SHOWNORMAL);
  end;
end;

procedure TMainForm.TopicBrowser_ChangeDownloadState(Sender: TObject);
begin
  // gsbNXgXV
  RepaintListViewTimer.Enabled := true;

  // ^uĕ`
  RepaintTabTimer.Enabled := true;

  ChangeTab();
end;

procedure TMainForm.RepaintTabTimerTimer(Sender: TObject);
begin
  RepaintTabTimer.Enabled := false;

  TopicTabControl.DoubleBuffered := true;
  TopicTabControl.Repaint;
  TopicTabControl.DoubleBuffered := false;
end;

procedure TMainForm.RepaintListViewTimerTimer(Sender: TObject);
begin
  RepaintListViewTimer.Enabled := false;

  TopicListView.DoubleBuffered := true;
  TopicListView.Repaint;
  TopicListView.DoubleBuffered := false;
end;

// {^\z
procedure TMainForm.CreateBoardButton;
var
  I, J    : integer;
  button  : TToolButton;
  newmenu : TPopupMenu;
  newmenuitem  : TMenuItem;
  categorymenu : TMenuItem;
  category     : TBoardCategory;
begin

  FBoardButtonMenuList.Clear;

  //
  {
  eraseok := false;
  while eraseok = false do
  begin
    eraseok := true;
    for I := 1 to FBoardButtonList.Count - 1 do
      if FBoardButtonList[I] = 'Q˂' then
      begin
        FBoardButtonList.Delete(I);
        eraseok := false;
        break;
      end;
  end;
  }

  // remove
  for I := 0 to BoardButtonToolBar.ButtonCount - 1 do
  begin
    button := BoardButtonToolBar.Buttons[0];
    BoardButtonToolBar.RemoveControl(button);
    button.Free;
  end;

  //
  for I := FBoardButtonList.Count - 1 downto 0 do
  begin
    button := TToolButton.Create(BoardButtonToolBar);
    button.AutoSize  := true;
    button.Parent    := BoardButtonToolBar;
    button.Caption   := FBoardButtonList[I];
    button.Style     := tbsButton;
    button.OnMouseUp := BoardButtonToolBarMouseUp;

    newmenu := TPopupMenu.Create(BoardButtonToolBar);
    newmenu.AutoHotkeys := maManual;
    button.DropdownMenu := newmenu;
    FBoardButtonMenuList.Add(newmenu);

    if Copy(FBoardButtonList[I], 1, 2) = '' then
    begin

      category := nil;
      for J := 0 to  gBoardList.Categorys.Count - 1 do
      begin
        category := TBoardCategory(gBoardList.Categorys[J]);
        if CopyAfter(FBoardButtonList[I], 3) = category.CategoryName then
          break;
        category := nil;
      end;

      if category <> nil then
        for J := 0 to category.Boards.Count - 1 do
        begin

          newmenuitem := TMenuItem.Create(newmenu);
          newmenuitem.Caption := TBoard(category.Boards[J]).DisplayName;
          newmenuitem.AutoHotkeys := maManual;
          newmenuitem.OnClick := BoardButtonClick;
          newmenu.Items.Add(newmenuitem);
          FBoardButtonMenuList.Add(newmenuitem);
        end;
    end else
    begin
      button.OnMouseDown := BoardButtonMouseDown;
//      button.OnClick     := BoardButtonClick;
    end;

  end;

  // Q˂

  button := TToolButton.Create(BoardButtonToolBar);
  button.AutoSize := true;
  button.Parent   := BoardButtonToolBar;
  button.Caption  := 'Q˂';

  newmenu := TPopupMenu.Create(BoardButtonToolBar);
  newmenu.AutoHotkeys := maManual;
  button.DropdownMenu := newmenu;
  FBoardButtonMenuList.Add(newmenu);

  for I := 0 to  gBoardList.Categorys.Count - 1 do
  begin
    category := TBoardCategory(gBoardList.Categorys[I]);
    categorymenu := TMenuItem.Create(newmenu);
    categorymenu.Caption := category.CategoryName;
    newmenu.Items.Add(categorymenu); 
    FBoardButtonMenuList.Add(categorymenu);

    for J := 0 to category.Boards.Count - 1 do
    begin
      newmenuitem := TMenuItem.Create(categorymenu);
      newmenuitem.Caption := TBoard(category.Boards[J]).DisplayName;
      newmenuitem.OnClick := BoardButtonClick;
      categorymenu.Add(newmenuitem);
      FBoardButtonMenuList.Add(newmenuitem);
    end;
  end;

end;

procedure TMainForm.CoolBarResize(Sender: TObject);
var
  I             : integer;
  cl_iditems    : TStringArray;
  cl_breakitems : TStringArray;
  cl_widthitems : TStringArray;
  band          : TCoolBand;
begin

  SetLength(cl_iditems, 0);
  SetLength(cl_breakitems, 0);
  SetLength(cl_widthitems, 0);

  if FRestoreCoolBands then
  begin
    FRestoreCoolBands := false;

    CoolBar.Bands.BeginUpdate;
    cl_iditems    := Split(gConfig.CoolBarBandId, ',');
    cl_breakitems := Split(gConfig.CoolBarBandBreak, ',');
    cl_widthitems := Split(gConfig.CoolBarBandWidth, ',');
    if (Length(cl_iditems)    >= 3) and
       (Length(cl_breakitems) >= 3) and
       (Length(cl_widthitems) >= 3) then
    begin
      for I := 2 downto 0 do
      begin
        band := TCoolBand(CoolBar.Bands.FindItemID(StrToIntNeo(cl_iditems[i])));
        band.Index := i;
        band.Break := (Trim(UpperCase(cl_breakitems[i])) <> 'FALSE');
        band.Width := StrToIntNeo(cl_widthitems[i]);
      end;
    end;
    CoolBar.Bands.EndUpdate;
  end;

end;

procedure TMainForm.SaveBoardButton;
begin

  FBoardButtonList.SaveToFile(AppPath('favboard.idx'));

end;

procedure TMainForm.BoardButtonToolBarCustomized(Sender: TObject);
begin

{
  FBoardButtonList.Clear;
  for I := 1 to BoardButtonToolBar.ButtonCount - 1 do
    if BoardButtonToolBar.Buttons[I].Visible = true then
      FBoardButtonList.Add(BoardButtonToolBar.Buttons[I].Caption);

  //CreateBoardButton;
  SaveBoardButton;
  }
end;

// gsbN_E[h
procedure TMainForm.ReceiveActiveTabActionExecute(Sender: TObject);
var
  b: TTopicBrowser;

begin
  b := GetActiveTab;
  OpenTab(b.Topic, false);
end;

procedure TMainForm.CloseActiveTabActionExecute(Sender: TObject);
begin
  CloseTabToolButtonClick(CloseTabToolButton);
end;

procedure TMainForm.TabBeforeActionExecute(Sender: TObject);
var
  index : integer;
begin
  index := TopicTabControl.TabIndex;
  if index > 0 then TopicTabControl.TabIndex := index - 1;
  ChangeTab();
end;

procedure TMainForm.TabForwardActionExecute(Sender: TObject);
var
  index : integer;
begin
  index := TopicTabControl.TabIndex;
  if index < TopicTabControl.Tabs.Count - 1 then TopicTabControl.TabIndex := index + 1;
  ChangeTab();
end;

procedure TMainForm.ChangeLimitAllActiveTabExecute(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetActiveTab();
  if ActiveTab = nil then exit;

  ActiveTab.ChangeViewLimit(0);
end;

procedure TMainForm.ChangeStyle1ActionExecute(Sender: TObject);
begin
  StyleSub1ToolButton.Down := not StyleSub1ToolButton.Down;
  StyleChange(StyleSub1ToolButton);
end;

procedure TMainForm.ChangeStyle2ActionExecute(Sender: TObject);
begin
  StyleSub2ToolButton.Down := not StyleSub2ToolButton.Down;
  StyleChange(StyleSub2ToolButton);
end;

procedure TMainForm.ChangeStyle3ActionExecute(Sender: TObject);
begin
  StyleSub3ToolButton.Down := not StyleSub3ToolButton.Down;
  StyleChange(StyleSub3ToolButton);
end;

procedure TMainForm.CreateOfflineFolderClick(Sender: TObject);
var
  createform : TCreateOfflineFolderForm;
  cancel     : boolean;
  foldername : string;
  folderpath : string;
  board      : TStringList;
begin

  createform := TCreateOfflineFolderForm.Create(self);
  createform.ShowModal;
  cancel     := createform.Cancel;
  foldername := createform.FolderName;
  createform.Release;
  createform.Free;

  if cancel then exit;

  folderpath := AppPath(foldername + '.idx');

  if AnsiCompareStr(foldername, '') = 0 then 
  begin 
    exit; 
  end;

  if FileExists(folderpath) then
  begin
    ShowMessage('ɓ̑qɂ܂');
    exit;
  end;

  if LastDelimiter('\/:,;*"<>|', foldername) > 0 then
  begin
    ShowMessage('\/:,;*"<>| ͎̕g܂');
    exit;
  end;

  // {[ht@C̍쐬
  board := TStringList.Create;
  board.SaveToFile(folderpath);
  board.Free; 

  gBoardList.Free;
  gBoardList := TBoardList.Create;

  RefreshBoardListBox;

end;

procedure TMainForm.RemoveOfflineFolderClick(Sender: TObject);
var
  index     : Integer;
  item      : TBoardListBoxItem;
  board     : TOfflineBoard;
begin

  index := BoardListBox.ItemIndex;
  if (index < 0) or (index >= FBoardListBoxItems.Count) then
    exit;

  item := TBoardListBoxItem(FBoardListBoxItems[index]);
  if (item.Board <> nil) and (item.Board is TOfflineBoard) then
  begin
    board := TOfflineBoard(item.Board);

    // TNƍ폜
    DeleteFile(AppPath(board.DisplayName + '.idx'));

    gBoardList.Free;
    gBoardList := TBoardList.Create;
    RefreshBoardListBox;
    BoardListBoxClick(BoardListBox);
  end;
end;

procedure TMainForm.FavoritePopupMenuPopup(Sender: TObject);
var
  I         : integer;
  ActiveTab : TTopicBrowser;
begin

  ActiveTab := GetActiveTab();
  for I := 1 to gBoardList.MyFolder.Boards.Count - 1 do
  begin
    if not (TBoard(gBoardList.MyFolder.Boards[I]) is TOfflineBoard) then
    begin
      continue;
    end;
    FavoritePopupMenu.Items[I - 1].Checked := false;
    if (ActiveTab <> nil) and (ActiveTab.Topic <> nil) then
    begin
        FavoritePopupMenu.Items[I - 1].Checked :=
          TOfflineBoard(gBoardList.MyFolder.Boards[I]).IsHave(ActiveTab.Topic);
    end;
  end;
  
end;

procedure TMainForm.FavoriteMenuItemClick(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
  board     : TOfflineBoard;
begin

  ActiveTab := GetActiveTab();
  if ActiveTab <> nil then
    if ActiveTab.Topic <> nil then
    begin
      board := TOfflineBoard(gBoardList.MyFolder.Boards[TMenuItem(Sender).Tag]);
      if board.IsHave(ActiveTab.Topic) then
        board.RemoveTopic(ActiveTab.Topic)
      else
        board.AppendTopic(ActiveTab.Topic);
    end;

end;

procedure TMainForm.BoardListBoxMouseDown(Sender: TObject;
                                          Button: TMouseButton;
                                          Shift: TShiftState;
                                          X, Y: Integer);
var
  index: integer;
  pos: TPoint;
begin

  pos.X := x;
  pos.Y := y;
  index := BoardListBox.ItemAtPos(Pos, True);
  if index < 0 then
  begin
    index := BoardListBox.Count - 1;
  end;
  BoardListBox.Selected[index] := True;

  ReleaseCapture;
end;

procedure TMainForm.TopicTabControlMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin

{

    ActiveTab := GetActiveTab();
    if (ActiveTab = nil) or (ActiveTab.Topic = nil) then
    begin
      ToolTip.UnVisible;
      Exit;
    end;
    Index := GetPointedTab();
    if Index < 0 then Exit;

    //if ToolTip.HintText <> TTopicBrowser(FBrowserList[index]).Topic.Title then
      ToolTip.SetHint(TTopicBrowser(FBrowserList[index]).Topic.Title);

}

end;

procedure TMainForm.TopicTabControlDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if not (Source is TTabControl) then 
    Accept := False; 
end;

procedure TMainForm.TopicTabControlDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var 
  Index : Integer; 
  PT : TPoint;
begin 
  if not (Sender is TTabControl) then Exit; 

  GetCursorPos(PT); 
  Index := GetTabIndexAtPoint(PT);

  if (Index < 0) or (Index = TopicTabControl.TabIndex) then Exit; 

  FBrowserList.Move(TopicTabControl.TabIndex, Index); 
  TopicTabControl.TabIndex := Index;
  ChangeTab(); 
end;

procedure TMainForm.BoardListBoxDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if not (Source is TTabControl) then
    Accept := False;
end;

procedure TMainForm.BoardListBoxDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var 
  ActiveTab : TTopicBrowser; 
  TabIndex     : Integer; 
  Index        : Integer; 
  Pos          : TPoint; 
  Board        : TBoard; 
  OfflineBoard : TOfflineBoard; 
  Topic        : TTopic; 
begin 
  ActiveTab := GetActiveTab(); 
  if (ActiveTab = nil) or (ActiveTab.Topic = nil) then Exit;

  TabIndex := (Source as TTabControl).TabIndex; 
  Pos.X := X; 
  Pos.Y := Y; 
  Index := (Sender as TListBox).ItemAtPos(Pos, True); 

  if (Index < 1) or (Index > gBoardList.MyFolder.Boards.Count) then Exit; 

  Board := gBoardList.MyFolder.Boards[Index - 1]; 
  if Board is TOfflineBoard then 
  begin 
    OfflineBoard := TOfflineBoard(Board);
    Topic := TTopicBrowser(FBrowserList[TabIndex]).Topic; 
    if not OfflineBoard.IsHave(Topic) then 
    begin 
      OfflineBoard.AppendTopic(Topic); 
      if FSelectedBoard = OfflineBoard then 
        OpenBoard(OfflineBoard); 
    end; 
  end; 
  TopicTabControl.EndDrag(false); 
end;


{ Topic Priority Related }

procedure TMainForm.SetPriorityMenuItemClick(Sender: TObject); 
var 
  i : Integer; 
  MenuItem : TMenuItem; 
  Item     : TListItem; 
  Topic    : TTopic; 
begin 
  Item := TopicListView.Selected; 
  if Item <> nil then 
  begin 
    Topic    := TTopic(FTopicList[Item.Index]);
    MenuItem := TMenuItem(Sender); 
    // do check selected priority 
    for i := 0 to MenuItem.Count - 1 do 
      if Topic.Priority = StrToInt(MenuItem[i].Caption) then 
        MenuItem.Items[i].Checked := True; 
  end; 
end; 

procedure TMainForm.SetPriorityPlusItemMenuClick(Sender: TObject);
var
  Priority : Integer; 
  MenuItem : TMenuItem; 
begin 
  MenuItem := TMenuItem(Sender); 
  Priority := StrToInt(MenuItem.Caption); 
  SetSelectedTopicPriority(Priority); 
end; 


procedure TMainForm.TopicListViewPopupMenuPopup(Sender: TObject);
var 
  Item : TListItem; 
  I    : Integer; 
begin 

  Item := TopicListView.Selected; 
  if Item <> nil then 
  begin 
    for i := 0 to TopicListViewPopupMenu.Items.Count - 1 do 
      TopicListViewPopupMenu.Items[i].Enabled := True; 

    // if not yet retrieved 
    if TTopic(FTopicList[Item.Index]).GotMessageCount = 0 then
    begin 
      TrashMenuItem.Enabled    := False; 
    //  FavoriteMenuItem.Enabled := False; 
    end; 
  end else
  begin
    for i := 0 to TopicListViewPopupMenu.Items.Count - 1 do
    begin
      TopicListViewPopupMenu.Items[i].Enabled := False;
    end;
  end;

  if gConfig.AlwaysNewTab then
  begin
    OpenNewTabMenuItem.Caption := '̃^uŊJ'
  end else
  begin
    OpenNewTabMenuItem.Caption := 'V^uŊJ';
  end;
end;

procedure TMainForm.SetSelectedTopicPriority(Priority : Integer);
var
  Topic : TTopic;
  Item  : TListItem;
begin
  Item := TopicListView.Selected;
  if Item <> nil then 
  begin 
    Topic := TTopic(FTopicList[Item.Index]); 
    if Topic.Priority <> Priority then 
    begin 
      Topic.Priority := Priority; 
      Topic.SaveIdx(); 
      TopicListView.Repaint; 
    end; 
  end;
end; 
{ /Topic Priority Related }

procedure TMainForm.TopicPagePopupMenuPopup(Sender: TObject);
var
  ActiveTab : TTopicBrowser;
  i : Integer;
begin
    ActiveTab := GetActiveTab();
    if (ActiveTab = nil) or (ActiveTab.Topic = nil) then
      for i := 0 to TopicPagePopupMenu.Items.Count - 1 do
        TopicPagePopupMenu.Items[i].Enabled := False
    else
      for i := 0 to TopicPagePopupMenu.Items.Count - 1 do
        TopicPagePopupMenu.Items[i].Enabled := True;

end;

// wʒũ^uCfbNX擾 
function TMainForm.GetTabIndexAtPoint(Point : TPoint) : Integer; 
var 
  Info  : TTCHitTestInfo; 
begin 
  Info.pt := TopicTabControl.ScreenToClient(Point); 
  Info.flags := TCHT_ONITEM; 
  result := TabCtrl_HitTest(TopicTabControl.Handle, @Info); 
end; 


// wʒũ^u擾 
function TMainForm.GetTabAtPoint(Point : TPoint) : TTopicBrowser; 
var 
  index : Integer; 
begin 
  index := GetTabIndexAtPoint(Point); 
  if (index >= 0) and (index < FBrowserList.Count) then 
    result := TTopicBrowser(FBrowserList[index])
  else 
    result := nil; 
end;

// {^ҏWtH[̕\ 
procedure TMainForm.EditBoardButtonMenuItemClick(Sender: TObject); 
var 
  Point : TPoint;
  EditBoardButtonForm : TEditBoardButtonForm;
begin 
  // FBoardButtonList ܂BfsłB 
  EditBoardButtonForm := TEditBoardButtonForm.Create(self); 
  GetCursorPos(point); 
  EditBoardButtonForm.Left := Point.X - EditBoardButtonForm.Width div 2; 
  EditBoardButtonForm.Top  := Point.Y - EditBoardButtonForm.Height div 3; 
  if EditBoardButtonForm.Top < 0 then 
    EditBoardButtonForm.Top := 0;
  EditBoardButtonForm.BoardButtonList := FBoardButtonList;
  EditBoardButtonForm.ShowModal;
  if not EditBoardButtonForm.Cancel then 
  begin 
    CreateBoardButton(); 
    SaveBoardButton(); 
  end; 
  EditBoardButtonForm.Free; 
end;

procedure TMainForm.OpenAllCategoryActionExecute(Sender: TObject);
var
  I : integer;
begin

  for I := 0 to gBoardList.Categorys.Count - 1 do
    TBoardCategory(gBoardList.Categorys[I]).Opened := true;  

  RefreshBoardListBox;

end;

procedure TMainForm.CloseAllCategoryActionExecute(Sender: TObject);
var
  I : integer;
begin

  for I := 0 to gBoardList.Categorys.Count - 1 do
  begin
    TBoardCategory(gBoardList.Categorys[I]).Opened := false;
  end;

  RefreshBoardListBox;
end;

procedure TMainForm.InputMemoMenuItemClick(Sender: TObject);
var 
  Item  : TListItem; 
  Topic : TTopic; 
  Memo  : string; 
begin 
  Item := TopicListView.Selected; 
  if Item <> nil then 
  begin 
    Topic := TTopic(FTopicList[Item.Index]); 
    Memo  := InputBox('', Topic.Title, Topic.Memo); 
    if Memo <> Topic.Memo then 
    begin 
      Topic.Memo := Memo; 
      Topic.SaveIdx(); 
      TopicListView.Repaint; 
    end; 
  end;
end;

procedure TMainForm.LogSweeperActionExecute(Sender: TObject);
var
  LogSweeperForm : TLogSweeperForm;
begin
  LogSweeperForm := TLogSweeperForm.Create(self);
  LogSweeperForm.ShowModal;
  LogSweeperForm.Free;
end;

procedure TMainForm.FormIdle(Sender: TObject; var Done: Boolean); 
var 
  P : TPoint; 
  Control : TControl; 
  ActiveTab : TTopicBrowser; 
  i : Integer; 
begin

  try
    if (gConfig.AutoFocus = false) or
       (FActive = false) then exit;

    if self.Active = false then exit;

    GetCursorPos(P);
    Control := FindDragTarget(P, True);

    if FMouseControl <> Control then
    begin
      FMouseControl := Control;
      if FMouseControl = BoardListBox then
        BoardListBox.SetFocus
      else if FMouseControl = TopicListView then
      begin
        Rightpanel.SetFocus; // ̂̍sȂƃuEUListViewœȂ
        TopicListView.SetFocus;
      end else
      if FMouseControl is TWebBrowser then
      begin
        ActiveTab := GetActiveTab();
        if ActiveTab <> nil then
          for i := 0 to ActiveTab.ComponentCount - 1 do
            if ActiveTab.Components[i] is TWebBrowser then
              if TWebBrowser(ActiveTab.Components[i]).document <> nil then
                olevariant(TWebBrowser(ActiveTab.Components[i]).document).parentWindow.focus;
      end;
    end;

  except on Exception do ;
  end;
  
end;

procedure TMainForm.FormDeactivate(Sender: TObject);
begin
  FActive := false;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  FActive := true;
end;

procedure TMainForm.GoTrayActionExecute(Sender: TObject);
begin

  // ^XNgCɑޔ
  TrayIcon.Visible := true;
  self.Visible := false;

end;

procedure TMainForm.TrayIconMouseClick(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

  // ^XNgC߂
  TrayIcon.Visible := false;
  self.Visible := true;

end;

procedure TMainForm.OpenSelectedTopic;
var
  item: TListItem;
  isNewTab: Boolean;

begin
  if not IsOpeningTopic then
  begin
    IsOpeningTopic := True;

    item := TopicListView.Selected;
    if item <> nil then
    begin
      isNewTab := (GetAsyncKeyState(VK_SHIFT) < 0) xor gConfig.AlwaysNewTab;
      OpenTab(FTopicList[item.Index], isNewTab);
    end;

    IsOpeningTopic := False;
  end;
end;

procedure TMainForm.TopicListViewKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_RETURN : OpenSelectedTopic();
  end;
end;

procedure TMainForm.BoardListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of 
    VK_RETURN   : BoardListBoxClick(Sender);
    VK_MULTIPLY   : OpenAllCategoryActionExecute(Sender); 
    VK_SUBTRACT   : CloseAllCategoryActionExecute(Sender);
  end;
end;

procedure TMainForm.BoardListViewSetVisible(const Visible, IsNormalMode : boolean); 
begin 
  if Visible then 
  begin 
    LeftPanel.Visible := true; 
    LeftPanel.Width   := gConfig.BoardListBoxWidth; 
    RightPanel.Align  := alNone; 
    Splitter1.Visible := true; 
    Splitter1.Align   := alNone; 
    Splitter1.Width   := 3; 
    Splitter1.Left    := LeftPanel.Width; 
    Splitter1.Align   := alLeft; 
    RightPanel.Left   := Splitter1.Left + Splitter1.Width; 
    RightPanel.Align  := alClient; 
  end else 
  begin 
    gConfig.BoardListBoxWidth := LeftPanel.Width; 
    LeftPanel.Visible  := false; 
    Splitter1.Visible  := false; 
  end; 
end; 

procedure TMainForm.TopicListViewSetVisible(const Visible, IsNormalMode : boolean); 
begin 
  if Visible then 
  begin 
    TopicListView.Visible := true; 
    if IsNormalMode then 
    begin 
      TopicListView.Align  := alTop; 
      TopicListView.Height := gConfig.TopicListViewHeight; 
    end else 
    begin 
      TopicListView.Align  := alLeft; 
      TopicListView.Width  := gConfig.TopicListViewWidth; 
    end; 
  end else 
  begin 
    // StyleSub2ToolButton ܂ StyleSub3ToolButton ꂽƂA 
    //  BrowserPanel \ĂƂ݂̂ɁA TopicListView ̍/ۑ 
    if (TopicListView.Visible <> Visible) and BrowserPanel.Visible then 
      if IsNormalMode then 
        gConfig.TopicListViewHeight := TopicListView.Height 
      else 
        gConfig.TopicListViewWidth  := TopicListView.Width;
    TopicListView.Visible := false;
    BrowserPanel.Align    := alClient; 
  end; 
end; 

procedure TMainForm.BrowserPanelSetVisible(const Visible, IsNormalMode : boolean); 
begin 
  if Visible then 
  begin 
    BrowserPanel.Visible := true; 
    BrowserPanel.Align   := alNone; 
    if IsNormalMode then 
    begin 
      BrowserPanel.Top   := Splitter2.Top + Splitter2.Height; 
    end else 
    begin 
      BrowserPanel.Left  := Splitter2.Left + Splitter2.Width; 
    end; 
    BrowserPanel.Align   := alClient; 
  end else 
  begin 
    BrowserPanel.Visible := false; 
    TopicListView.Align  := alClient; 
  end; 
end; 

procedure TMainForm.Spliter2SetVisible(const Visible, IsNormalMode : boolean); 
begin 
  if Visible then 
  begin 
    Splitter2.Visible  := true; 
    Splitter2.Align    := alNone; 
    if IsNormalMode then 
    begin 
      Splitter2.Height := 3; 
      Splitter2.Top    := TopicListView.Height; 
      Splitter2.Align  := alTop; 
    end else 
    begin 
      Splitter2.Width  := 3; 
      Splitter2.Left   := TopicListView.Width; 
      Splitter2.Align  := alLeft; 
    end; 
  end else 
  begin 
    Splitter2.Visible  := false; 
  end; 
end;

procedure TMainForm.CopyUrlTopicListClick(Sender: TObject); 
var 
  Topic : TTopic; 
begin 
  if (TopicListView.ItemIndex <> -1) then 
  begin 
    Topic := TTopic(FTopicList[TopicListView.ItemIndex]);
    Clipboard.AsText := Topic.BrowserUrl;
  end; 
end; 

procedure TMainForm.CopyTitleUrlTopicListClick(Sender: TObject); 
var 
  Topic : TTopic; 
begin 
  if (TopicListView.ItemIndex <> -1) then 
  begin 
    Topic := TTopic(FTopicList[TopicListView.ItemIndex]); 
    Clipboard.AsText := Topic.Title + #13#10 + Topic.BrowserUrl; 
  end; 
end; 

procedure TMainForm.OpenByBrowserTopicListClick(Sender: TObject); 
var 
  Topic : TTopic; 
begin 
  if (TopicListView.ItemIndex <> -1) then 
  begin 
    Topic := TTopic(FTopicList[TopicListView.ItemIndex]); 
    OpenBrowser(Topic.BrowserUrl); 
  end; 
end; 

procedure TMainForm.OpenKatju88SiteMenuItemClick(Sender: TObject); 
const 
  URL = 'http://katju88project.sourceforge.jp/'; 
begin 
  OpenBrowser(URL); 
end; 

procedure TMainForm.OpenSupportBoardMenuItemClick(Sender: TObject); 
const 
  URL = 'http://katju88project.sourceforge.jp/forum/'; 
begin 
  OpenBrowser(URL); 
end; 

procedure TMainForm.Open2chMenuItemClick(Sender: TObject); 
const 
  URL = 'http://www.2ch.net/'; 
begin 
  OpenBrowser(URL); 
end; 

procedure TMainForm.Open2chGuideMenuItemClick(Sender: TObject); 
const 
  URL = 'http://www.2ch.net/guide/'; 
begin 
  OpenBrowser(URL); 
end; 

procedure TMainForm.TrashMenuItemClick(Sender: TObject); 
var 
  Index : Integer; 
  Topic : TTopic; 
begin 
  Index := TopicListView.ItemIndex; 
  if Index <> -1 then 
  begin 
    Topic := TTopic(FTopicList[Index]); 
    Topic.EraseLog; 
    TopicListView.DoubleBuffered := True;
    TopicListView.Repaint;
    TopicListView.DoubleBuffered := False; 
  end; 
end; 

procedure TMainForm.IETextSizeMenuItemClick(Sender: TObject); 
var 
  ActiveTab : TTopicBrowser;
  Size      : Integer; 
begin 
  ActiveTab := GetActiveTab; 
  if Assigned(ActiveTab) and (ActiveTab is TTopicBrowserIE) then 
  begin 
    if TMenuItem(Sender).Name = 'IETextSizeGiantMenuItem' then 
      Size := 4 
    else if TMenuItem(Sender).Name = 'IETextSizeLargeMenuItem' then 
      Size := 3
    else if TMenuItem(Sender).Name = 'IETextSizeMediumMenuItem' then 
      Size := 2 
    else if TMenuItem(Sender).Name = 'IETextSizeSmallMenuItem' then 
      Size := 1 
    else if TMenuItem(Sender).Name = 'IETextSizeTinyMenuItem' then 
      Size := 0 
    else 
      Size := 2; 

    TMenuItem(Sender).Checked := True; 
    TTopicBrowserIE(ActiveTab).SetTextSize(Size); 
  end; 
end;

procedure TMainForm.SendMailMenuItemClick(Sender: TObject);
begin

  ShowMessage('fB ');

end;

procedure TMainForm.GoToToolButtonClick(Sender: TObject); 
begin 
  if UrlEdit.Text <> '' then 
    OpenUrl(Sender, UrlEdit.Text); 
end; 

procedure TMainForm.UrlEditChange(Sender: TObject); 
begin 
  if UrlEdit.Text <> '' then 
    GoToToolButton.Hint := UrlEdit.Text + ' J' 
  else 
    GoToToolButton.Hint := ''; 
end; 

procedure TMainForm.AddressToolBarResize(Sender: TObject); 
begin 
  // ŃTCYĂȂ̂ 
  UrlEdit.Width := AddressToolBar.Width; 
end; 

procedure TMainForm.N1Click(Sender: TObject); 
begin 
  if UrlEdit.Text <> '' then 
    OpenBrowser(UrlEdit.Text); 
end; 

procedure TMainForm.URL3Click(Sender: TObject); 
begin 
  if UrlEdit.Text <> '' then 
    Clipboard.AsText := UrlEdit.Text; 
end;

procedure TMainForm.BoardButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

  BoardButtonClick(sender);


end;

procedure TMainForm.BoardButtonClick(Sender: TObject);
var
  I, J     : integer;
  caption  : string;
  category : TBoardCategory;
begin

  if sender is TMenuItem then
    caption := TMenuItem(Sender).Caption
  else if sender is TToolButton then
  begin
    caption := TToolButton(sender).Caption;
    TToolButton(sender).Down := true;
    Application.ProcessMessages;
//    sleep(5000);
  end;

  for I := 0 to gBoardList.Categorys.Count - 1 do
  begin
    category := TBoardCategory(gBoardList.Categorys[I]);
    for J := 0 to category.Boards.Count - 1 do
      if TBoard(category.Boards[J]).DisplayName = caption then
      begin
        OpenBoard(TBoard(category.Boards[J]));
        break;
      end;
  end;

  if sender is TToolButton then
  begin
    TToolButton(sender).Down := false;
  end;

end;

procedure TMainForm.ChangeTopicListViewColumnPadding;
var
  defaultImageHeight: Integer;
  newImageHeight: Integer;
  i: Integer;
  image, mask, tmpImage: TBitMap;
begin

  // C[WXg쐬
  defaultImageHeight := TopicListViewImageList.Height;
  newImageHeight     := defaultImageHeight + gConfig.TopicListViewColumnPadding;

  if Assigned(FImageList) then
  begin
    FImageList.Free;
  end;
  FImageList := TImageList.CreateSize(defaultImageHeight, newImageHeight);

  for i := 0 to TopicListViewImageList.Count - 1 do
  begin
    image    := TBitMap.Create;
    mask     := TBitMap.Create;
    tmpImage := TBitMap.Create;

    TopicListViewImageList.GetBitmap(i, tmpImage);

    image.Width     := defaultImageHeight;
    image.Height    := newImageHeight;
    mask.Width      := image.Width;
    mask.Height     := image.Height;
    tmpImage.Width  := image.Width;
    tmpImage.Height := image.Height;

    image.Canvas.Brush.Color := tmpImage.Canvas.Pixels[0,0];
    image.Canvas.FillRect(Rect(0,0,defaultImageHeight, newImageHeight));
    image.Canvas.Draw(0, gConfig.TopicListViewColumnPadding div 2, TmpImage);

    mask.Canvas.Draw(0, 0, Image);
    mask.Mask(mask.Canvas.Pixels[0,0]);

    FImageList.Add(image, mask);

    image.Free;
    mask.Free;
    tmpImage.Free;
  end;

  if TopicListView.SmallImages <> nil then
    TopicListView.SmallImages.Free;

  TopicListView.SmallImages := FImageList;
end;

end.

